program airport;

const MAXN = 10000;
const MAXL = 1000;
const RFE = MAXN*MAXN div 8;

type pgm = record
	     actions : array[1..MAXN] of longint;
	     len : longint;
	   end;
     locks = array[1..MAXL] of boolean;

var p1, p2 : pgm;
    l, j, s1, s2: longint;
    reachable, reachable_prev:array[0..MAXN] of boolean;
    locked1, locked2:locks;
    can1, can2 : boolean;
    rfrom : array[0..RFE-1] of byte;

procedure readpgm(var p:pgm);
var act:char;
    i : longint;
begin
readln(p.len);
for i := 1 to p.len do
  begin
    read(act);
    read(act);
    read(act);
    readln (p.actions[i]);
    if act = 'L' then p.actions[i] := -p.actions[i];
  end;
end;

procedure exaction(var lcks:locks; act:longint);
begin
if act > 0 then lcks[act] := true else lcks[-act] := false;
end;

function check_deadlock(s1, s2:longint):boolean;
begin
  if (p1.actions[s1+1] < 0) or (p2.actions[s2+1] < 0) then
     begin
     check_deadlock := false;
     exit;
     end;
  check_deadlock := locked1[p2.actions[s2+1]] and locked2[p1.actions[s1+1]];
end;

function get_rfrom(s1,s2:longint):boolean;
var off:longint;
    vl,msk:byte;
begin
  off := (s1 - 1) * p1.len + (s2 - 1);
  vl := rfrom[off div 8];
  msk := 1 shl (off mod 8);
  get_rfrom := (vl and msk) <> 0;
end;

procedure set_rfrom(s1,s2:longint; from1:boolean);
var off:longint;
    vl,msk:byte;
begin
  if (s1 = 0) or (s2 = 0) then exit;
  off := (s1 - 1) * p1.len + (s2 - 1);
  vl := rfrom[off div 8];
  msk := 1 shl (off mod 8);
  if from1 then vl := vl or msk else vl := vl and not msk;
  rfrom[off div 8] := vl;
end;

var out:array[1..20000] of char;

procedure deadlock(s1,s2:longint);
var n,i:longint;
begin
  n := 0;
  while (s1 > 0) and (s2 > 0) do
    begin
      inc(n);
      if get_rfrom(s1,s2) then
        begin
	  out[n]:='1';
	  dec(s1);
	end
      else
        begin
	  out[n]:='2';
	  dec(s2);
	end
    end;

  while s1 > 0 do
    begin
      inc(n);
      out[n]:='1';
      dec(s1);
    end;
  while s2 > 0 do
    begin
      inc(n);
      out[n]:='2';
      dec(s2);
    end;
  for i := 1 to l do
    begin
      locked1[i] := false;
      locked2[i] := false;
    end;
  s1 := 0; s2 := 0;
  for i := 1 to n do
    begin
      write(out[n+1-i]);

      if out[n+1-i] = '1' then
        begin
	  inc (s1);
	  assert ((p1.actions[s1] < 0) or not locked2[p1.actions[s1]]);
	  exaction (locked1, p1.actions[s1]);
	end
      else
        begin
	  inc (s2);
	  assert ((p2.actions[s2] < 0) or not locked1[p2.actions[s2]]);
	  exaction (locked2, p2.actions[s2]);
	end;
    end;
  writeln;
end;

procedure check_nointersect;
var i:longint;
begin
for i := 1 to l do
  assert (not (locked1[i] and locked2[i]));
end;

begin
read(l);
readpgm (p1);
readpgm (p2);

for j := 1 to l do
  locked1[j] := false;

for j := 0 to p2.len do
  reachable_prev[j] := true;

for s1 := 1 to p1.len - 1 do
  begin
    for j := 1 to l do locked2[j] := false;

    {reachable[x] will be set true iff we can get just after the s1-th step of
     p1 and x-th step of p2

     We can get with the first pgm to any point, as long as we do not do anything
     in the second one}
    reachable[0] := true;

    exaction (locked1, p1.actions[s1]);
    for s2 := 1 to p2.len - 1 do
      begin
        exaction (locked2, p2.actions[s2]);
        {to (s1, s2), we can get from (s1-1, s2) or (s1, s2-1), assuming that we
	 can perform the instructions}
	can1 := (p1.actions[s1] < 0) or not locked2[p1.actions[s1]];
	can2 := (p2.actions[s2] < 0) or not locked1[p2.actions[s2]];
	if (can1 and reachable_prev[s2]) or (can2 and reachable[s2-1]) then
	  begin
	    reachable[s2] := true;
	    {writeln (s1,',',s2,' reachable');}
	    {check_nointersect;}
	    set_rfrom (s1, s2, can1 and reachable_prev[s2]);
	    if check_deadlock (s1, s2) then
	      begin
	        deadlock (s1, s2);
		exit;
	      end;
	  end
	else
	  reachable[s2] := false;
      end;
    for j := 0 to p2.len - 1 do
      reachable_prev[j] := reachable[j];
  end;

  writeln ('The performances will always finish.');
end.
