program tiso_lin;

const MAXN = 1001001;
	   
type off = record
	      id   : longint;    {* ID ot this deparment, to be assigned during the algorithm *}
	      boss : longint;    {* index of the superior. Prime minister has 0 *}
	      enum : longint;    {* number of 'not solved' direct employees *}
	      e	   : array[1..3] of longint; {* ID's of direct employees *}
	   end;	   
var o	     : array[0..MAXN] of off;        {* prime minister will be 1, 0 is god *}
   zas,queue : array[0..MAXN] of longint;    {* zas[0] is god too, no gods in queue though *}
   qs,qe     : longint;
   free_id   : longint;
	   
procedure read_input;
var c	  : char;
   i,free : longint;
begin
   i:=0; zas[0]:=0; free:=1;
   repeat
      read(c);
      if c='(' then begin
	 inc(o[zas[i]].enum);
	 o[free].boss:=zas[i];
	 inc(i); zas[i]:=free; inc(free);
      end else if c=')' then begin
	 if o[zas[i]].enum=0 then begin queue[qe]:=zas[i]; inc(qe) end;
	 dec(i);
      end else begin writeln('Bad input data!'); halt end;
   until i=0;
end;

function equal(var a,b : off) : boolean;
var i : integer;
begin
   equal:=false;
   for i:=1 to 3 do if a.e[i] <> b.e[i] then exit;
   equal:=true;
end;

procedure collect;
var e,num,i,tmp	: longint;
   boss		: ^off;
begin
   num:=free_id;
   {* assign the id's and compute the number of unique *}
   for i:=qs to qe-1 do begin
      if (i=qs) or not equal(o[queue[i-1]],o[queue[i]]) then begin inc(free_id) end;
      o[queue[i]].id:=free_id-1;
   end;
   writeln(free_id-num);
   
   {* propagate the id's to the parents and add them to the queue when they are ready *}
   e:=qe;
   while qs<e do begin
      tmp:=o[queue[qs]].boss;
      boss:=@(o[tmp]);
      boss^.e[boss^.enum]:=o[queue[qs]].id;
      dec(boss^.enum); inc(qs);
      if boss^.enum>0 then continue;
      queue[qe]:=tmp; inc(qe);
   end;
end;

type bucket = record
		 data : longint;
		 next : longint;
	      end;    
var buckets : array[0..MAXN] of bucket;
   starts   : array[0..MAXN] of longint;
   full	    : array[0..MAXN] of longint;
   used	    : longint;

procedure prepare_birds;
var i : longint;
begin
   for i:=0 to MAXN do starts[i]:=-1;
end;

{* we must get unique off's in queue[qs..qe-1] next to each other *}
{* by unique we mean that their e's are equivalent *}
procedure birds_of_a_feather_flock_together(l,r	: longint);
var i,j,b,id : longint;
begin
   for i:=3 downto 1 do begin
      {* 1st bucket the indexes according to e[i] *}
      used:=0;
      for j:=l to r do begin
	 id:=o[queue[j]].e[i];
	 buckets[used].data:=queue[j];
	 buckets[used].next:=starts[id];
	 starts[id]:=used;
	 full[used]:=id;
	 inc(used);
      end;
      {* 2nd copy indexes back to the queue *}
      used:=l;
      for j:=0 to r-l do begin
	 b:=starts[full[j]];
	 starts[full[j]]:=-1;
	 while b<>-1 do begin
	    queue[used]:=buckets[b].data;
	    inc(used);
	    b:=buckets[b].next;
	 end
      end;
   end;
end;

begin
   qs:=0; qe:=0; free_id:=1;
   read_input;
   prepare_birds;
   while {*not god*} queue[qs]<>0 do begin
      collect;
      birds_of_a_feather_flock_together(qs,qe-1);
   end;
end.  
