program tiso_qs;

const MAXN = 1001001;
	   
type off = record
	      id   : longint;    {* ID ot this deparment, to be assigned during the algorithm *}
	      boss : longint;    {* index of the superior. Prime minister has 0 *}
	      e	   : qword;      {* sequence if indexes of direct employees *}
	      enum : longint;    {* number of 'not solved' direct employees *}
	   end;	   
var o	     : array[0..MAXN] of off;        {* prime minister will be 1, 0 is god *}
   zas,queue : array[0..MAXN] of longint;    {* zas[0] is god too, no gods in queue though *}
   qs,qe     : longint;
   free_id   : longint;
	   
procedure read_input;
var c	  : char;
   i,free : longint;
begin
   i:=0; zas[0]:=0; free:=1;
   repeat
      read(c);
      if c='(' then begin
	 inc(o[zas[i]].enum);
	 o[free].boss:=zas[i];
	 inc(i); zas[i]:=free; inc(free);
      end else if c=')' then begin
	 if o[zas[i]].enum=0 then begin queue[qe]:=zas[i]; inc(qe) end;
	 dec(i);
      end else begin writeln('Bad input data!'); halt end;
   until i=0;
end;

procedure collect;
var e,num,i,tmp : longint;   
begin
   num:=free_id;
   {* assign the id's and compute the number of unique *}
   for i:=qs to qe-1 do begin
      if (i=qs) or (o[queue[i-1]].e<>o[queue[i]].e) then begin inc(free_id) end;
      o[queue[i]].id:=free_id-1;
   end;
   writeln(free_id-num);
   
   {* propagate the id's to the parents and add them to the queue when they are ready *}
   e:=qe;
   while qs<e do begin
      tmp:=o[queue[qs]].boss;
      o[tmp].e:=(o[tmp].e shl 20) or o[queue[qs]].id;
      dec(o[tmp].enum); inc(qs);
      if o[tmp].enum>0 then continue;
      queue[qe]:=tmp; inc(qe);
   end;
end;

{* we must get unique off's in queue[qs..qe-1] next to each other *}
{* by unique we mean that their e's are equivalent *}
{* just now, it is stupid quicksort *}
procedure birds_of_a_feather_flock_together(l,r	: longint);
var e	   : qword;
   tmp,i,j : longint;
begin
   if l>=r-5 then begin
      for i:= l to r-1 do for j:= i+1 to r do
	 if o[queue[i]].e > o[queue[j]].e then begin tmp:=queue[i]; queue[i]:=queue[j]; queue[j]:=tmp end;
      exit
   end;

   i:=l; j:=r; e:=o[queue[(l+r) div 2]].e;
   repeat
      while o[queue[i]].e < e do inc(i);
      while o[queue[j]].e > e do dec(j);
      if i<=j then begin
	 tmp:=queue[i]; queue[i]:=queue[j]; queue[j]:=tmp;
	 inc(i); dec(j);
      end;
   until i>j;
   if j-l>0 then birds_of_a_feather_flock_together(l,j);
   if r-i>0 then birds_of_a_feather_flock_together(i,r);
end;

begin
   qs:=0; qe:=0; free_id:=1;
   read_input;
   while {*not god*} queue[qs]<>0 do begin
      collect;
      birds_of_a_feather_flock_together(qs,qe-1);
   end;
end.  
