program nasty;
const
  MAXTERMS=100000;
  MAXB=36;
type
  term = record
           op : char;
	   arg : Array[1..2] of LongInt;
         end;
var
  N, B, i : LongInt;
  terms_stack : Array[1..MAXTERMS] of term;
  terms : Array[1..MAXTERMS] of term;
  num_terms, terms_top : LongInt;
  Res : Array[0..MAXB] of Byte;

function DigitToNum(c : Char) : Byte;
begin
  if (Ord(c) >= Ord('0')) and (Ord(c) <= Ord('9')) then
    DigitToNum := Ord(c) - Ord('0')
  else
    DigitToNum := Ord(c) - Ord('A') + 10;
end;

function ReadNum(var F : Text; c : Char) : Byte;
var
  last_c : Char;
begin
  repeat
    last_c := c;
    Read(F, c);
  until (c = ' ') or EoLn(F);
  ReadNum := DigitToNum(last_c);
end;

procedure ReadExp(var F : Text);
var
  c : Char;
  tmp : String[16];
begin
  c := 'a';
  while not EoLn(F) do begin
    Read(F, c);
    if c = 'x' then begin
      Inc(terms_top);
      terms_stack[terms_top].op := 'x';
      if not EoLn(F) then
        Read(F, c);	{Space}
    end
    else if (c = '+') or (c = '-') or (c = '*') then begin
      terms[num_terms+1] := terms_stack[terms_top-1];
      terms[num_terms+2] := terms_stack[terms_top];
      Dec(terms_top);
      terms_stack[terms_top].arg[1] := num_terms+1;
      terms_stack[terms_top].arg[2] := num_terms+2;
      terms_stack[terms_top].op := c;
      Inc(num_terms, 2);
      if not EoLn(F) then
        Read(F, c);	{Space}
    end
    else if (Ord(c) = 10) or (Ord(c) = 13) then
      break
    else begin
      Inc(terms_top);
      terms_stack[terms_top].op := Chr(128+ReadNum(F, c));
    end;
  end;
  Inc(num_terms);
  terms[num_terms] := terms_stack[terms_top];
  if terms_top <> 1 then
    WriteLn('Term stack not empty after reading the whole expression!');
   ReadLn(F, tmp);	{EoLn}
end;

function Evaluate(act_term : LongInt; num : Byte) : Byte;
var
  v : Array[1..2] of Integer;
  act_arg : Byte;
begin
  if terms[act_term].op = 'x' then begin
    Evaluate := num;
    Exit;
  end
  else if Ord(terms[act_term].op) >= 128 then begin
    Evaluate := Ord(terms[act_term].op) - 128;
    Exit;
  end;

  for act_arg := 1 to 2 do begin
    v[act_arg] := Evaluate(terms[act_term].arg[act_arg], num);
  end;
  if terms[act_term].op = '+' then
    Evaluate := (v[1]+v[2]) mod B
  else if terms[act_term].op = '*' then
    Evaluate := (v[1]*v[2]) mod B
  else {Operator -}
    Evaluate := (v[1]-v[2]+B) mod B;
end;

procedure Precompute;
var
  i : Byte;
begin
  for i := 0 to B-1 do begin
    Res[i] := Evaluate(num_terms, i);
  end
end;

procedure ProcessNum;
var
  Line : String[255];
  num : Byte;
  c : Char;
begin
  ReadLn(Line);
  num := DigitToNum(Line[Length(Line)]);
  num := Res[num];
  if num < 10 then
    c := Chr(Ord('0') + num)
  else
    c := Chr(Ord('A') + num - 10);
  WriteLn(c);
end;

begin
  ReadLn(B, N);
  num_terms := 0;
  terms_top := 0;
  ReadExp(input);
  Precompute;
  for i := 1 to N do
    ProcessNum;
end.
